<?php

require_once 'base/GpeOcupacaomEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 * 
 * @package Entity
 * 
 * @author  alessandrobartels
 */
class GpeOcupacaomEntity extends GpeOcupacaomEntityBase
{

    private $_nrOrg;
    private $_mesCompetencia;
    private $_historicos;


    /** Construtor
     *
     * @param integer    $id             Identificador.
     * @param integer    $nrOrg          Numero da Organizacao.
     * @param TkDateTime $mesCompetencia Mes de competencia.
     *
     * @author alessandrobartels
     */
    public function __construct($id = null, $nrOrg = null, TkDateTime $mesCompetencia = null){
        parent::__construct($id);

        $this->_nrOrg = $nrOrg;
        $this->_mesCompetencia = $mesCompetencia;
    }


    public function retornaOcupacao($nrOcupacao){
        $ocupacao = GpeOcupacaom::retornaOcupacao($this->_nrOrg, $nrOcupacao, $this->_mesCompetencia);
        return $ocupacao;
    }


    public function retornaOcupacaoPorCodigoIntegracao($cdIntegracao){
        $ocupacao = GpeOcupacaom::retornaOcupacaoPorCodigoIntegracao(
            $this->_nrOrg, $cdIntegracao, $this->_mesCompetencia
        );
        return $ocupacao;
    }


    public function incluiOcupacao($nrtipoocupacao){
        try{
            $this->setNrtipoocupacao($nrtipoocupacao);
            $this->setDtinivigencia($this->_mesCompetencia);
            $this->setNrorg($this->_nrOrg);

            $this->persist();

            return true;
        }
        catch (Exception $e){
            return false;
        }
    }

    /**
     * @param $nrorg
     * @param $nrtipoocupacao
     * @param $dtinivigencia
     * @autor jorgefonseca
     */
    public function insereOcupacao($nrorg, $nrtipoocupacao, $dtinivigencia) {
        $this->setNrorg($nrorg);
        $this->setNrtipoocupacao($nrtipoocupacao);
        $this->setDtinivigencia($dtinivigencia);
    }

    /**
     * @return GpeOcupacaohEntity[]
     */
    public function getHistoricos() {
        if (!$this->_historicos) {
            $this->_historicos = self::getEntitiesByWhere('NRORG = ? AND NROCUPACAOM = ?');
        }
        return $this->_historicos;
    }
    
}

