import { Modal, ModalService } from '@zeedhi/common';

export class ModalController {
  private modal!: Modal;

  public async createModal(path: string) {
    if (!this.modal) this.modal = await ModalService.createFromJson(path, true);
  }

  public destroyModal() {
    if (this.modal) this.modal.destroy();
  }

  public openModal() {
    this.modal.show();
  }

  public closeModal() {
    this.modal.hide();
  }

  public getModal() {
    return this.modal;
  }
}
