package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class NutrientesCardapioPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");

    By telaNutrientesCardapio = By.xpath("//span[text() = 'Nutrientes do Cardápio']");

    By campoRelatorio = By.xpath("//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By relatorioAnaliticoData = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Nutrientes do Cardápio (Analítico por Data)']");
    By relatorioAnaliticoServico = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Nutrientes do Cardápio (Analítico por Serviço)']");
    By relatorioSinteticoData = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Nutrientes do Cardápio (Sintético por Data)']");
    By relatorioSinteticoServico = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Nutrientes do Cardápio (Sintético por Serviço)']");
    By relatorioColuna = By.xpath("//ul[@class='list zh-new-select-list']//li[text()='Nutrientes do Cardápio (Coluna)']");
    By relatorioEtiqueta = By.xpath("//ul[@class='list zh-new-select-list']//li[text() = 'Nutrientes do Cardápio (Etiqueta)']");

    By botaoCampounidade = By.xpath("//div[@id=\"NMFILIAL\"]//span[@style=\"background-image: none; display: block;\"]");

    By campoDataInicial = By.id("DTINTERVAL_START");
    By campoDataFinal = By.id("DTINTERVAL_END");

    By todoServicos = By.xpath("//div[@data-zh-id='103985514241080510764663']//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoServico = By.id("NMSERVICO");
    By servicoSolicitacao = By.xpath("//div[@data-zh-field-name='NMSERVICO']//span[text() = 'SOLICITACAO']");
    By servicoDistribuicao = By.xpath("//div[@data-zh-field-name='NMSERVICO']//span[text() = 'DISTRIBUICAO']");

    By todosNutrientes = By.xpath("//div[@data-zh-id='103985514227776731854668']//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoNutrientes = By.id("NMNUTRIENTE");
    By campoTodosNutrientes = By.xpath("//div[@class=\"header-content\"]//div[@class=\"zh-theader zh-ripple-effect\"]");
//    By nutrienteCarboidrato = By.xpath("//div[@data-zh-field-name='NMNUTRIENTE']//span[text() = 'CARBOIDRATO']");
//    By nutrienteQuilocaloria = By.xpath("//div[@data-zh-field-name='NMNUTRIENTE']//span[text() = 'QUILOCALORIA']");
//    By nutrienteProteina = By.xpath("//div[@data-zh-field-name='NMNUTRIENTE']//span[text() = 'PROTEINA']");

    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"103985514240438253704652\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioIntervaloData = By.xpath("//div[@data-zh-id=\"103985514214851082531909\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"1039855142739871074659\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNutriente = By.xpath("//div[@data-zh-id=\"103985514226365359724665\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioTipoPrato = By.xpath("//div[@data-zh-id=\"10398551429089960374670\"]//div[@class=\"zh-validation\"]/span");

    By todosTipoPrato = By.xpath("//div[@data-zh-id='103985514232289474134673']//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoTipoPrato = By.id("NMTIPOPRAT");
    By tipoPratoPrincipal = By.xpath("//div[@data-zh-field-name='NMTIPOPRAT']//span[text() = 'PRATO PRINCIPAL']");
    By tipoPratosFeijao = By.xpath("//div[@data-zh-field-name='NMTIPOPRAT']//span[text() = 'FEIJAO']");

    By botaoOk = By.xpath("//section[@class='popup-container']//div[@class='zh-footer-right']");

    By checkBoxTodosServicos = By.id("zh-checkbox-ALLCDSERVFILI");
    By checkBoxTodosNutrientes = By.id("zh-checkbox-ALLCDNUTRIENTE");
    By checkBoxTodosTipoPrato = By.id("zh-checkbox-ALLCDTIPOPRATO");

    By campoImprimirOpcoes = By.xpath("//label[@for=\"zh-checkbox-TODASOPCAO\" and @class=\"zh-box-label\"]");
    By campoImprimirNDPCal = By.xpath("//label[@for=\"zh-checkbox-DSIMPNDPCAL\" and @class=\"zh-box-label\"]");
    By campoNutrienteHabilitado = By.xpath("//label[@for=\"zh-checkbox-ALLCDNUTRIENTE\" and @class=\"zh-box-label\"]");
    By checkBoxImprimirOpcoes = By.id("zh-checkbox-TODASOPCAO");
    By checkBoxImprimirNDPCal = By.id("zh-checkbox-DSIMPNDPCAL");

    By botaoRelatorio = By.xpath("//div[@class='zh-footer-right']");
    By botaoSimDesejaContinuar = By.xpath("//footer[@class='zh-footer-alert']//span[text()='Sim']");
    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']/div");
    By botaoConfirmar = By.xpath("//section[@id='popup']//div[@class='zh-footer-right']//span[text() = 'Confirmar']");

    public void acessarTela() {
        try {
            Thread.sleep(6000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Nutrientes do Cardápio");
        click(telaNutrientesCardapio);
    }

    public void selecionaRelatorio(String nomeDoRelatorio) {
        if(nomeDoRelatorio == "Nutrientes do Cardápio (Analítico por Data)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioAnaliticoData);
        } else if (nomeDoRelatorio == "Nutrientes do Cardápio (Analítico por Serviço)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioAnaliticoServico);
        } else if (nomeDoRelatorio == "Nutrientes do Cardápio (Sintético por Data)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioSinteticoData);
        } else if (nomeDoRelatorio == "Nutrientes do Cardápio (Sintético por Serviço)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioSinteticoServico);
        } else if (nomeDoRelatorio == "Nutrientes do Cardápio (Coluna)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioColuna);
        } else if (nomeDoRelatorio == "Nutrientes do Cardápio (Etiqueta)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioEtiqueta);
        }
    }

    public void preencherDatas(String dataInicial, String dataFinal) {
        super.preencherDatas(campoDataInicial, campoDataFinal, dataInicial, dataFinal);
    }

    public void selecionarServicos() {
        click(todoServicos);
        click(campoServico);
        click(servicoSolicitacao);
        click(servicoDistribuicao);
        click(botaoOk);
    }

    public void selecionarTipoPrato() {
        click(todosTipoPrato);
        click(campoTipoPrato);
        click(tipoPratoPrincipal);
        click(tipoPratosFeijao);
        click(botaoOk);
    }

    public void selecionarNutrientes() {
        click(todosNutrientes);
        click(campoNutrientes);
        click(campoTodosNutrientes);
        click(botaoOk);
    }

    public void geraRelatorio(String nomeRelatorio) {
        if(nomeRelatorio == "Nutrientes do Cardápio (Coluna)") {
            click(botaoRelatorio);
            click(botaoSimDesejaContinuar);
            click(tipoPdf);
            click(botaoConfirmar);
        } else {
            super.geraRelatorio(botaoRelatorio, tipoPdf, botaoConfirmar);
        }
        fecharGuiaDoRelatorio();
    }

    public void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

    public void verificarCamposObrigatorios() {
        click(botaoCampounidade);
        click(todoServicos);
        click(todosNutrientes);
        click(todosTipoPrato);
        click(botaoRelatorio);

        //mensagens de campo obrigatorio
        String unidade = getText(mensagemObrigatorioUnidade);
        String intervaloData = getText(mensagemObrigatorioIntervaloData);
        String servico = getText(mensagemObrigatorioServico);
        String nutriente = getText(mensagemObrigatorioNutriente);
        String tipoPrato = getText(mensagemObrigatorioTipoPrato);

        String mensagemEsperada = "Campo obrigatório";
        String mensagemEsperadaIntervaloData = "Start and End date is Required!";
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório, no campo unidade");
        Assert.assertEquals(intervaloData, mensagemEsperadaIntervaloData, "Verificação da mensagem de campo obrigatório, no campo intervalo data");
        Assert.assertEquals(servico, mensagemEsperada, "Verificação da mensagem de campo obrigatório, no campo serviço");
        Assert.assertEquals(nutriente, mensagemEsperada, "Verificação da mensagem de campo obrigatório, no campo nutriente");
        Assert.assertEquals(tipoPrato, mensagemEsperada, "Verificação da mensagem de campo obrigatório, no campo tipo de prato");
    }

    public void verificarOpcoesHabilitadasPelosRelatorios() {
        clicarCampoSelecionarValor(campoRelatorio, relatorioAnaliticoData);
        boolean imprimirOpcoes = returnIfElementIsEnabled(checkBoxImprimirOpcoes);
        boolean imprimirNDPCal = returnIfElementIsEnabled(checkBoxImprimirNDPCal);
        boolean checkTodosServicos = returnIfElementIsEnabled(checkBoxTodosServicos);
        boolean checkTodosNutriente = returnIfElementIsEnabled(checkBoxTodosNutrientes);
        boolean checkTodosTioPrato = returnIfElementIsEnabled(checkBoxTodosTipoPrato);
        Assert.assertEquals(imprimirOpcoes, true, "Verificar se o campo 'imprimir opções' está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Data)'");
        Assert.assertEquals(imprimirNDPCal, true, "Verificar se o campo 'imprimir NDPCal' está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Data)'");
        Assert.assertEquals(checkTodosServicos, true, "Verificar se o check-box 'Todos' os serviços está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Data)'");
        Assert.assertEquals(checkTodosNutriente, true, "Verificar se o check-box 'Todos' os nutrientes está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Data)'");
        Assert.assertEquals(checkTodosTioPrato, true, "Verificar se o check-box 'Todos' os tipos de prato está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Data)'");


        clicarCampoSelecionarValor(campoRelatorio, relatorioAnaliticoServico);
        imprimirOpcoes = returnIfElementIsEnabled(checkBoxImprimirOpcoes);
        imprimirNDPCal = returnIfElementIsEnabled(checkBoxImprimirNDPCal);
        checkTodosServicos = returnIfElementIsEnabled(checkBoxTodosServicos);
        checkTodosNutriente = returnIfElementIsEnabled(checkBoxTodosNutrientes);
        checkTodosTioPrato = returnIfElementIsEnabled(checkBoxTodosTipoPrato);
        Assert.assertEquals(imprimirOpcoes, true, "Verificar se o campo 'imprimir opções' está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Serviço)'");
        Assert.assertEquals(imprimirNDPCal, true, "Verificar se o campo 'imprimir NDPCal' está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Serviço)'");
        Assert.assertEquals(checkTodosServicos, true, "Verificar se o check-box 'Todos' os serviços está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Serviço)'");
        Assert.assertEquals(checkTodosNutriente, true, "Verificar se o check-box 'Todos' os nutrientes está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Serviço)'");
        Assert.assertEquals(checkTodosTioPrato, true, "Verificar se o check-box 'Todos' os tipos de prato está habilitado quando o relatório 'Nutrientes do Cardápio (Analítico por Serviço)'");

        clicarCampoSelecionarValor(campoRelatorio, relatorioSinteticoData);
        imprimirOpcoes = returnIfElementIsEnabled(checkBoxImprimirOpcoes);
        imprimirNDPCal = returnIfElementIsEnabled(checkBoxImprimirNDPCal);
        checkTodosServicos = returnIfElementIsEnabled(checkBoxTodosServicos);
        checkTodosNutriente = returnIfElementIsEnabled(checkBoxTodosNutrientes);
        checkTodosTioPrato = returnIfElementIsEnabled(checkBoxTodosTipoPrato);
        Assert.assertEquals(imprimirOpcoes, true, "Verificar se o campo 'imprimir opções' está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Data)'");
        Assert.assertEquals(imprimirNDPCal, true, "Verificar se o campo 'imprimir NDPCal' está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Data)'");
        Assert.assertEquals(checkTodosServicos, true, "Verificar se o check-box 'Todos' os serviços está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Data)'");
        Assert.assertEquals(checkTodosNutriente, true, "Verificar se o check-box 'Todos' os nutrientes está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Data)'");
        Assert.assertEquals(checkTodosTioPrato, true, "Verificar se o check-box 'Todos' os tipos de prato está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Data)'");

        clicarCampoSelecionarValor(campoRelatorio, relatorioSinteticoServico);
        imprimirOpcoes = returnIfElementIsEnabled(checkBoxImprimirOpcoes);
        imprimirNDPCal = returnIfElementIsEnabled(checkBoxImprimirNDPCal);
        checkTodosServicos = returnIfElementIsEnabled(checkBoxTodosServicos);
        checkTodosNutriente = returnIfElementIsEnabled(checkBoxTodosNutrientes);
        checkTodosTioPrato = returnIfElementIsEnabled(checkBoxTodosTipoPrato);
        Assert.assertEquals(imprimirOpcoes, true, "Verificar se o campo 'imprimir opções' está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Serviço)'");
        Assert.assertEquals(imprimirNDPCal, true, "Verificar se o campo 'imprimir NDPCal' está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Serviço)'");
        Assert.assertEquals(checkTodosServicos, true, "Verificar se o check-box 'Todos' os serviços está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Serviço)'");
        Assert.assertEquals(checkTodosNutriente, true, "Verificar se o check-box 'Todos' os nutrientes está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Serviço)'");
        Assert.assertEquals(checkTodosTioPrato, true, "Verificar se o check-box 'Todos' os tipos de prato está habilitado quando o relatório 'Nutrientes do Cardápio (Sintético por Serviço)'");

        clicarCampoSelecionarValor(campoRelatorio, relatorioColuna);
        imprimirOpcoes = returnIfElementIsEnabled(checkBoxImprimirOpcoes);
        imprimirNDPCal = returnIfElementIsEnabled(checkBoxImprimirNDPCal);
        checkTodosServicos = returnIfElementIsEnabled(checkBoxTodosServicos);
        checkTodosNutriente = returnIfElementIsEnabled(checkBoxTodosNutrientes);
        checkTodosTioPrato = returnIfElementIsEnabled(checkBoxTodosTipoPrato);
        Assert.assertEquals(imprimirOpcoes, false, "Verificar se o campo 'imprimir opções' está habilitado quando o relatório 'Nutrientes do Cardápio (Coluna)'");
        Assert.assertEquals(imprimirNDPCal, false, "Verificar se o campo 'imprimir NDPCal' está habilitado quando o relatório 'Nutrientes do Cardápio (Coluna)'");
        Assert.assertEquals(checkTodosServicos, true, "Verificar se o check-box 'Todos' os serviços está habilitado quando o relatório 'Nutrientes do Cardápio (Coluna)'");
        Assert.assertEquals(checkTodosNutriente, false, "Verificar se o check-box 'Todos' os nutrientes está habilitado quando o relatório 'Nutrientes do Cardápio (Coluna)'");
        Assert.assertEquals(checkTodosTioPrato, true, "Verificar se o check-box 'Todos' os tipos de prato está habilitado quando o relatório 'Nutrientes do Cardápio (Coluna)'");

        clicarCampoSelecionarValor(campoRelatorio, relatorioEtiqueta);
        imprimirOpcoes = returnIfElementIsEnabled(checkBoxImprimirOpcoes);
        imprimirNDPCal = returnIfElementIsEnabled(checkBoxImprimirNDPCal);
        checkTodosServicos = returnIfElementIsEnabled(checkBoxTodosServicos);
        checkTodosNutriente = returnIfElementIsEnabled(checkBoxTodosNutrientes);
        checkTodosTioPrato = returnIfElementIsEnabled(checkBoxTodosTipoPrato);
        Assert.assertEquals(imprimirOpcoes, false, "Verificar se o campo 'imprimir opções' está habilitado quando o relatório 'Nutrientes do Cardápio (Etiqueta)'");
        Assert.assertEquals(imprimirNDPCal, false, "Verificar se o campo 'imprimir NDPCal' está habilitado quando o relatório 'Nutrientes do Cardápio (Etiqueta)'");
        Assert.assertEquals(checkTodosServicos, true, "Verificar se o check-box 'Todos' os serviços está habilitado quando o relatório 'Nutrientes do Cardápio (Etiqueta)'");
        Assert.assertEquals(checkTodosNutriente, false, "Verificar se o check-box 'Todos' os nutrientes está habilitado quando o relatório 'Nutrientes do Cardápio (Etiqueta)'");
        Assert.assertEquals(checkTodosTioPrato, true, "Verificar se o check-box 'Todos' os tipos de prato está habilitado quando o relatório 'Nutrientes do Cardápio (Etiqueta)'");
    }

    public void verificarCamposDeImpressao() {
        boolean checkImprimirOpcao = returnIfElementIsSelected(checkBoxImprimirOpcoes);
        boolean checkImprimirNDPCal = returnIfElementIsSelected(checkBoxImprimirNDPCal);
        Assert.assertEquals(checkImprimirOpcao, true, "Verificar se assim que a tela carrega, o chec-box 'imprimir opção' já está marcado");
        Assert.assertEquals(checkImprimirNDPCal, false, "Verificar se assim que a tela carrega, o chec-box 'imprimir NDPCal' já está marcado");

        click(campoImprimirOpcoes);
        checkImprimirOpcao = returnIfElementIsSelected(checkBoxImprimirOpcoes);
        Assert.assertEquals(checkImprimirOpcao, false, "Verificar se enquanto o check-box do 'imprimir opções' está marcado, caso o usuário clique no campo 'imprimir opção', o check-box do mesmo ficará desmarcado");

        click(campoImprimirNDPCal);
        checkImprimirNDPCal = returnIfElementIsSelected(checkBoxImprimirNDPCal);
        Assert.assertEquals(checkImprimirNDPCal, true, "Verificar se enquanto o check-box do 'imprimir NDPCal' está desmarcado, caso o usuário clique no campo 'imprimir NDPCal', o check-box do mesmo ficará marcado");
    }

}
