package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.NutrientesCardapioFlows;
import com.javaseleniumtemplate.pages.NutrientesCardapioPage;
import org.testng.annotations.Test;

public class NutrientesCardapioTests extends TestBase {

    NutrientesCardapioPage nutrientesCardapioPage;
    NutrientesCardapioFlows nutrientesCardapioFlows;
    LoginFlows loginFlows;

    @Test
    public void relatorioAnaliticoData() {
        emitiRelatorio("Nutrientes do Cardápio (Analítico por Data)");
    }

    @Test
    public void relatorioAnaliticoServico() {
        emitiRelatorio("Nutrientes do Cardápio (Analítico por Serviço)");
    }

    @Test
    public void relatorioSinteticoData() {
        emitiRelatorio("Nutrientes do Cardápio (Sintético por Data)");
    }

    @Test
    public void relatorioSinteticoServico() {
        emitiRelatorio("Nutrientes do Cardápio (Sintético por Serviço)");
    }

    @Test
    public void relatorioColuna() {
        emitiRelatorio("Nutrientes do Cardápio (Coluna)");
    }

    @Test
    public void relatorioEtiqueta() {
        emitiRelatorio("Nutrientes do Cardápio (Etiqueta)");
    }

    public void emitiRelatorio(String nomeRelatorio) {
        nutrientesCardapioPage = new NutrientesCardapioPage();
        nutrientesCardapioFlows = new NutrientesCardapioFlows();
        loginFlows = new LoginFlows();

        String dataInicial = "01/08/2022";
        String dataFinal = "31/10/2022";

        loginFlows.efetuarLogin();
        nutrientesCardapioFlows.navegateNutrientesCardapio();
        nutrientesCardapioPage.selecionaRelatorio(nomeRelatorio);
        nutrientesCardapioPage.preencherDatas(dataInicial, dataFinal);
        nutrientesCardapioPage.geraRelatorio(nomeRelatorio);
        nutrientesCardapioPage.selecionarServicos();

        if(nomeRelatorio != "Nutrientes do Cardápio (Coluna)" && nomeRelatorio != "Nutrientes do Cardápio (Etiqueta)") {
            nutrientesCardapioPage.selecionarNutrientes();
        }
        nutrientesCardapioPage.selecionarTipoPrato();
        nutrientesCardapioPage.geraRelatorio(nomeRelatorio);

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }


    //verificar os campos obrigatório da tela
    //verificar quais campos (serviço, nutriente, tipo de prato, imprimir opção e imprimir NDPCal) estão habilitados de acordo com o relatório selecionado
    //verificar se os check-box de 'imprimir opção' e 'imprimir NDPCal' estão funcionando corretamente
    @Test
    public void verificarCamposObrigatorioECheckBox() {
        nutrientesCardapioPage = new NutrientesCardapioPage();
        nutrientesCardapioFlows = new NutrientesCardapioFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesCardapioFlows.navegateNutrientesCardapio();
        nutrientesCardapioPage.verificarCamposObrigatorios();
        nutrientesCardapioPage.refresh();
        nutrientesCardapioPage.verificarOpcoesHabilitadasPelosRelatorios();
        nutrientesCardapioPage.refresh();
        nutrientesCardapioPage.verificarCamposDeImpressao();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

}
